package ru.dbotthepony.mc.otm.menu.data;

import net.minecraft.world.inventory.ContainerData;
import org.apache.commons.lang3.ArrayUtils;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;

import java.math.BigDecimal;
import java.math.BigInteger;

public class BigDecimalDataContainer implements ContainerData {
	public static final int NETWORK_PAYLOAD_SIZE = 16;

	private BigDecimal value;
	// working with ints
	// networking as shorts
	// crazy.
	private final int[] buffer = new int[NETWORK_PAYLOAD_SIZE + 2];

	public BigDecimal getDecimal() {
		if (value != null) {
			return value;
		}

		byte[] _build = new byte[NETWORK_PAYLOAD_SIZE * 2];

		int build_index = 0;

		// read payload
		for (int i = 1; i <= NETWORK_PAYLOAD_SIZE; i++) {
			_build[build_index] = (byte) ((buffer[i] & 0xFF00) >> 8);
			_build[build_index + 1] = (byte) (buffer[i] & 0xFF);

			build_index += 2;
		}

		byte[] build = new byte[_build[0] & 0xFF];

		if (_build[0] != 0) {
			if (build.length > _build.length - 1) {
				OverdriveThatMatters.LOGGER.fatal("Tried to read {} bytes, while buffer allow only up to {} bytes to be read!", build.length, _build.length - 1);
				OverdriveThatMatters.LOGGER.fatal("buffer state: {}", ArrayUtils.toString(buffer));
				OverdriveThatMatters.LOGGER.fatal("decoded state: {}", ArrayUtils.toString(_build));
				return value = BigDecimal.ZERO;
			}

			System.arraycopy(_build, 1, build, 0, build.length);

			return value = new BigDecimal(new BigInteger(build), buffer[0]);
		}

		return value = BigDecimal.ZERO;
	}

	public void setDecimal(BigDecimal decimal) {
		if (decimal.equals(value)) {
			return;
		}

		value = decimal;

		int scale = decimal.scale();
		BigInteger integer = decimal.unscaledValue();

		buffer[0] = scale & 0xFFFF;
		buffer[1] = (scale & 0xFFFF0000) >>> 16;
		byte[] _build = integer.toByteArray();
		byte[] build = new byte[NETWORK_PAYLOAD_SIZE * 2];

		// insert, shift by one
		System.arraycopy(_build, 0, build, 1, Math.min(_build.length, NETWORK_PAYLOAD_SIZE * 4 - 1));

		// tell how many bytes are in there
		build[0] = (byte) _build.length;

		int build_index = 0;

		// write
		for (int i = 1; i <= NETWORK_PAYLOAD_SIZE; i++) {
			buffer[i] =
					(build[build_index] & 0xFF) << 8 |
					(build[build_index + 1] & 0xFF);

			build_index += 2;
		}
	}

	// override
	protected void updateValue() {

	}

	@Override
	public int get(int index) {
		updateValue();
		return buffer[index];
	}

	@Override
	public void set(int index, int _value) {
		if (buffer[index] == _value)
			return;

		value = null;
		buffer[index] = _value;
	}

	@Override
	public int getCount() {
		return NETWORK_PAYLOAD_SIZE + 2;
	}
}
