package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.Registry
import ru.dbotthepony.mc.otm.block.entity.BlockEntityItemMonitor
import ru.dbotthepony.mc.otm.menu.data.INetworkedItemViewSupplier
import ru.dbotthepony.mc.otm.menu.data.NetworkedItemView
import ru.dbotthepony.mc.otm.storage.ItemStackWrapper

class ItemMonitorMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: BlockEntityItemMonitor? = null
) : PoweredMatteryMenu(Registry.Menus.ITEM_MONITOR, p_38852_, inventory, tile), INetworkedItemViewSupplier {
	@JvmField
	val view = NetworkedItemView(inventory.player, this, tile == null)

	override fun getNetworkedItemView(): NetworkedItemView {
		return view
	}

	init {
		if (tile != null) {
			view.setComponent(tile.cell.storageGrid!!.getVirtualComponent(ItemStackWrapper::class.java))
		}

		addBatterySlot()
		addInventorySlots()
	}

	override fun broadcastChanges() {
		super.broadcastChanges()
		view.network()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return 1
	}
}